from matplotlib import pyplot as plt
import matplotlib
matplotlib.rcParams['font.family'] = 'FangSong' #显示FangSong中文仿宋字体
matplotlib.rcParams['font.size'] = '12'  #设置字体大小
plt.figure(figsize=(7,7))#创建一个绘图对象(窗口)，指定绘图对象的宽度和高度
#定义饼状图每块旁边的标签
labels = ('六分水','三分山','一分田')
#定义饼图中每块的大小
sizes = (6,3,1)
colors = ['red','yellowgreen','lightskyblue']
explode = (0,0,0.05) #0.05表示'一分田'那一块离开中心的距离 
plt.pie(sizes,explode=explode,labels=labels,colors=colors, labeldistance = 1.1, autopct = '%4.2f%%',shadow = True, startangle = 90,pctdistance = 0.5)
#labeldistance，文本的位置离饼的中心点有多远，1.1指1.1倍半径的位置
#autopct，圆里面的文本格式，%4.2f%%表示数字显示的宽度有四位，小数点后有2位
#shadow，饼是否有阴影，取False没有阴影，取True有阴影
#startangle，饼图的起始绘制角度，一般选择从90度开始
#pctdistance，百分比的text离圆心的距离，0.5指0.5倍半径的位置
plt.legend(loc="best")  #为饼图添加图例，loc="best"用来设置图例的位置
plt.show()



