import matplotlib.pyplot as plt
import numpy as np
a = np.arange(0.0, 5.0, 0.02)
plt.plot(a, np.sin(2*np.pi*a), 'k--')
# fontproperties也可用fontname代替
plt.ylabel('纵轴：振幅', fontproperties='Kaiti', fontsize=20) 
plt.xlabel('横轴：时间', fontproperties='Kaiti', fontsize=20)
plt.title(r'正弦波实例: $y=sin(2\pi x)$', fontproperties='Kaiti', fontsize=20)
''' xy=(2.25,1)指定箭头的位置，xytext=(3, 1.5)指定箭头的注解文本的位置，facecolor ='black'指定箭头填充的颜色，shrink=0.1指定箭头的长度，width=1指定箭头的宽度'''
plt.annotate(r'$\mu=100$', fontsize=15, xy=(2.25,1), xytext=(3, 1.5), arrowprops = dict(facecolor='black', shrink=0.1, width=1))
# text()可以在图中的任意位置添加文字，1, 1.5为文本在图像中的坐标
plt.text(1, 1.5, '正弦波曲线', fontproperties='Kaiti',fontsize=20)  #添加文本'正弦波曲线'
plt.axis([0, 5, -2, 2])  #指定x轴和y轴的取值范围
plt.grid(True)       #在绘图区域添加网格线
plt.show()
