class BiTNode:
    def __init__(self,value='*',left=None,right=None):
        self.value=value
        self.left=left
        self.right=right

class BiTree:
    def __init__(self):
        self.root=self.preCreateBiTree()
    
    #按先序遍历方式建立二叉树  
    def preCreateBiTree(self):
        temp = input('前序构建二叉树，请输入结点的值：')
        lst = BiTNode(temp)       #生成一个二叉树结点
        if temp!= '*':            #输入*认为不再继续向下创建结点
            print("输入左子树：")  #为刚才创建的lst结点创建左子树
            lst.left = self.preCreateBiTree()
            print("输入右子树：")
            lst.right = self.preCreateBiTree()
        return lst
            
    #前序遍历二叉树
    def preOrderTraverse(self,root):
        if root.value=='*':
            return '*'
        print(root.value, end=',')          #输出当前二叉树的根结点
        self.preOrderTraverse(root.left)    #递归输出根的左子树
        self.preOrderTraverse(root.right)   #递归输出根的右子树

    #中序遍历二叉树
    def inOrderTraverse(self,root):
        if root.value=='*':
            return
        self.inOrderTraverse(root.left) #中序遍历左子树
        print(root.value, end=',')          #遍历根结点
        self.inOrderTraverse(root.right) #中序遍历右子树

    #后序遍历二叉树
    def postOrderTraverse(self,root):
        if root.left.value!='*':
            self.postOrderTraverse(root.left)   #后序遍历左子树
        if root.right.value!='*':
            self.postOrderTraverse(root.right)  #后序遍历右子树
        print(root.value, end=',')           #遍历根结点
        
    #层序遍历
    def levelTraverse(self,root):
        if root.value== '*':
            return  '*'
        lst=[]                 # lst起队列的作用，遍历过的结点依次进入列表
        print(root.value, end=',')
        lst.append(root)
        while(len(lst)>0):
            node = lst.pop(0)
            if node.left.value!='*':
                print((node.left).value, end=',')
                lst.append(node.left)
            if node.right.value!='*':
                print((node.right).value, end=',')
                lst.append(node.right)

def main():
    tree=BiTree()
    tree.preCreateBiTree()
    print('前序遍历序列是：')
    tree.preOrderTraverse(tree.root)
    print('\n中序遍历序列是：')
    tree.inOrderTraverse(tree.root)
    print('\n后序遍历序列是：')
    tree.postOrderTraverse(tree.root)
    print('\n层序遍历序列是：')
    tree.levelTraverse(tree.root)

main()
