


class BiTree:
    '''基于列表实现结点类'''
    def __init__(self,value='*',left=None,right=None):
        self.value=value
        self.left=left
        self.right=right
    #按先序遍历方式建立二叉树  
    def preCreateBiTree(self):
        temp = input('前序构建二叉树，请输入结点的值：')
        lst = BiTree(temp)
        if temp != '*':         #输入*认为不再继续向下创建结点
            print("输入左子树：")
            lst.left = self.preCreateBiTree()
            print("输入右子树：")
            lst.right = self.preCreateBiTree()
        return lst
            
    #前序遍历二叉树
    def preOrderTraverse(self):
        print(self.value, end=',')           #输出当前二叉树的根结点
        if(self.value!= '*'):
            self.left.preOrderTraverse()    #递归输出左子树
            self.right.preOrderTraverse()   #递归输出右子树

    #中序遍历二叉树
    def inOrderTraverse(self):
        if self.left!=None:
            self.left.inOrderTraverse()    #中序遍历左子树
        print(self.value, end=',')          #遍历根结点
        if self.right!=None:
            self.right.inOrderTraverse()   #中序遍历右子树

    #后序遍历二叉树
    def postOrderTraverse(self):
        if self.left!=None:
            self.left.postOrderTraverse()   #后序遍历左子树
        if self.right!=None:
            self.right.postOrderTraverse()  #后序遍历右子树
        print(self.value, end=',')           #遍历根结点
        
    #层序遍历
    def levelTraverse(self):
        if self.value== '*':
            return
        lst=[]                 # lst起队列的作用，遍历过的结点依次进入列表
        print(self.value, end=',')
        lst.append(self)
        while(len(lst)>0):
            node = lst.pop(0)
            if node.left!=None:
                print((node.left).value, end=',')
                lst.append(node.left)
            if node.right!=None:
                print((node.right).value, end=',')
                lst.append(node.right)

def main():
    root=BiTree()
    root=root.preCreateBiTree()
    print('前序遍历序列是：')
    root.preOrderTraverse()
    print('\n中序遍历序列是：')
    root.inOrderTraverse()
    print('\n后序遍历序列是：')
    root.postOrderTraverse()
    print('\n层序遍历序列是：')
    root.levelTraverse()
      
main()
